; Copyright 2001 by EMT Software Inc. - by Scott Hull 07/02/01
;
; updated: 07/20/01
;
; This program draws 2D profiles standard keyed shafts.
;
; Data from ANSI B17.1  
;
(defun C:2DKSFT (/ #BORE #DCL-FILE #DCL-ID #DCL-LIST #DIA #FILE #HELP #KEY
 #SIZE #SIZELIST #X @ARC @BLOCK @INSERT @LINE @POLYARC @POLYLINE @SFT-DRAW
 *error*)

; start or R14 compatibility library
(if (= (substr (getvar "acadver") 1 2) "14")
 (progn
(defun vl-file-delete (%A) nil)

(defun vl-filename-mktemp (%A / #DIR)
 (cond
  ((setq #DIR (getenv "tmp")) nil)
  ((setq #DIR (getenv "temp")) nil)
  (T (setq #DIR "")))
 (strcat #DIR "\\" %A))

(defun vl-position (%A %B)
 (if (member %A %B) (- (length %B) (length (member %A %B)))))
))
; end of R14 compatibility library

 (defun *error* (%A)
  (if (= (type #FILE) 'FILE) (close #FILE))
  (cond
   ((= %A "Function cancelled") nil)
   (t (princ (strcat "\nerror: " %A "\007\n"))))
  (princ))

 (if (not (and (equal (getvar "ucsorg") (list 0.0 0.0 0.0))
               (equal (getvar "ucsxdir") (list 1.0 0.0 0.0))
               (equal (getvar "ucsydir") (list 0.0 1.0 0.0))))
  (progn (alert "You must be in the World UCS to use this program")
         (quit)))

 (setq #DCL-LIST (list
"ksft2d : dialog {"
"  label = \"2D Keyed shaft\";"
"    : row {"
"      : column {"
"        : popup_list {"
"          height = 3;"
"          key = \"size\";"
"          label = \"&Shaft diameter:\";"
"          width = 8;"
"        }"
"        : toggle {"
"          key = \"bore\";"
"          label = \"&Bore\";"
"        }"
"      }"
"      : boxed_radio_column {"
"        key = \"key\";"
"        label = \"Keyway\";"
"        : radio_button {"
"          key = \"square\";"
"          label = \"&Square\";"
"        }"
"        : radio_button {"
"          key = \"rectangle\";"
"          label = \"&Rectangle\";"
"        }"
"      }"
"    }"
"  spacer;"
"  ok_cancel_help_ohyeahcad_errtile;"
"}"
""
"ohyeahcad_button : retirement_button {"
"  key = \"ohyeahcad\";"
"  label = \"&ohyeahcad.com...\";"
"}"
""
"ok_cancel_help_ohyeahcad : column {"
"  : row {"
"    fixed_width = true;"
"    alignment = centered;"
"    ok_button;"
"    : spacer {"
"      width = 2;"
"    }"
"    cancel_button;"
"    : spacer {"
"      width = 2;"
"    }"
"    help_button;"
"    : spacer {"
"      width = 2;"
"    }"
"    ohyeahcad_button;"
"  }"
"}"
""
"ok_cancel_help_ohyeahcad_errtile : column {"
"  ok_cancel_help_ohyeahcad;"
"  errtile;"
"}"))

(setq #HELP (strcat
 "2D Keyed Shaft\n\n"
 "This program draws 2D profiles of standard shafts and bores with \n"
 "parallel keyways. You can specify the diameter, square or rectangular\n"
 "key and insertion point. The keyway size is automatically selected."))

;Shaft sizes
;
;"DIA" "SQR" "RECT"
(setq #SIZELIST (list
'(0.3125 0.09375 nil) 
'(0.375 0.09375 nil) 
'(0.4375 0.09375 nil)
'(0.500 0.125 0.9375)
'(0.5625 0.125 0.9375)
'(0.625 0.1875 0.125)
'(0.750 0.1875 0.125)
'(0.875 0.1875 0.125)
'(1.000 0.250 0.1875)
'(1.125 0.250 0.1875)
'(1.250 0.3125 0.250)
'(1.375 0.3125 0.250)
'(1.500 0.375 0.250)
'(1.750 0.375 0.250)
'(2.000 0.500 0.375)
'(2.250 0.500 0.375)
'(2.500 0.625 0.4375)
'(2.750 0.625 0.4375)
'(3.000 0.750 0.500)
'(3.250 0.750 0.500)
'(3.500 0.875 0.625)
'(3.750 0.875 0.625)
'(4.000 1.000 0.750)
'(4.500 1.000 0.750)
'(5.000 1.250 0.875)
'(5.500 1.250 0.875)
'(6.000 1.500 1.000)
'(6.500 1.500 1.000)
'(7.000 1.750 1.500)
'(7.500 1.750 1.500)
'(8.000 2.000 1.500)
'(9.000 2.000 1.500)
'(10.00 2.500 1.750)
'(11.00 2.500 1.750)))

 (defun @ARC (%A %B %C %D / #CEN)
  (setq #CEN (list (car %A) (cadr %A) (if (caddr %A) (caddr %A) 0)))
  (entmake (append (list '(0 . "ARC") '(8 . "0") (cons 10 #CEN)
   (cons 40 %B) (cons 50 %C) (cons 51 %D)))))

 (defun @BLOCK ()
  (entmake '((0 . "ENDBLK")))
  (entmake (list '(0 . "BLOCK") '(2 . "*XXX") '(70 . 1) '(10 0 0 0))))

 (defun @GRAY ()
  (if (not (caddr #SIZE))
   (progn
    (setq #KEY "square")
    (set_tile "key" #KEY)
    (mode_tile "key" 1))
   (mode_tile "key" 0)))

 (defun @INSERT (%A)
  (entmake (append
    (list '(0 . "INSERT") (cons 2 (entmake '((0 . "ENDBLK")))))
     %A (list (cons 41 1.0) (cons 42 1.0) (cons 43 1.0)))))

;%A - start point
;%B - endpoint
 (defun @LINE (%A %B / #A #B)
  (setq #A (if (caddr %A) (caddr %A) 0))
  (setq #B (if (caddr %B) (caddr %B) 0))
  (entmake (append '((0 . "LINE") (8 . "0"))
   (list (list 10 (car %A) (cadr %A) #A)
         (list 11 (car %B) (cadr %B) #B)))))

 (defun @POLYARC (%PT1 %PT2 %PT3 / #1-2 #2-3 #ANG1-2 #ANG2-3 #END
  #MID #PROJ1 #PROJ2 #PT0 #START)
  (setq #ANG1-2 (angle %PT1 %PT2)
        #ANG2-3 (angle %PT2 %PT3)
        #1-2 (polar %PT1 #ANG1-2 (* 0.5 (distance %PT1 %PT2)))
        #2-3 (polar %PT2 #ANG2-3 (* 0.5 (distance %PT2 %PT3)))
        #PROJ1 (polar #1-2 (+ #ANG1-2 (* 0.5 pi)) 1.0)
        #PROJ2 (polar #2-3 (+ #ANG2-3 (* 0.5 pi)) 1.0)
        #PT0 (inters #1-2 #PROJ1 #2-3 #PROJ2 nil)
        #START (angle #PT0 %PT1)
        #MID (angle #PT0 %PT2)
        #END (angle #PT0 %PT3))
  (if (or (and (< #START #END) (or (> #MID #END) (< #MID #START)))
          (and (< #MID #START) (> #MID #END)))
   (setq #START #END #END (angle #PT0 %PT1)))
  (@ARC #PT0 (distance #PT0 %PT1) #START #END))

 (defun @POLYLINE (%PTLIST / #1 #2 #3 #FIRST #LAST
  #PT1 #PT2 #PT3 #PTLIST)
  (setq #PTLIST %PTLIST 
        #FIRST (car #PTLIST)
        #LAST (last #PTLIST))
  (while (> (length #PTLIST) 1)
   (setq #1 (car #PTLIST)
         #2 (cadr #PTLIST)
         #3 (caddr #PTLIST)
         #PTLIST (cdr #PTLIST)
         #PT1 (list (car #1) (cadr #1))
         #PT2 (list (car #2) (cadr #2)))
   (if #3
    (setq #PT3 (list (car #3) (cadr #3))))
   (cond
    ((= (caddr #3) 1) 
     (@POLYARC #PT1 #PT2 #PT3)
     (setq #PTLIST (cdr #PTLIST)))
    (T (@LINE #PT1 #PT2)))))

 (defun @SFT-DRAW (/ #DP #P1 #P2 #P3 #P4 #P5 #P6 #PT0 #RAD #REC #SQR #W/2
  #Y0)
  (setq #SQR (cadr #SIZE) #REC (caddr #SIZE))
  (if (= #KEY "square")
   (setq #DP (/ #SQR 2.0))
   (setq #DP (/ #REC 2.0)))
  (if (= #BORE "1") (setq #DP (- #DP)))
  (setq #RAD (/ #DIA 2.0)
        #W/2 (/ #SQR 2.0)
        #Y0 (sqrt (- (expt #RAD 2) (expt #W/2 2)))
        #P1 (list #W/2 #Y0)
        #P2 (list #W/2 (- #Y0 #DP))
        #P3 (list (- #W/2) (cadr #P2))
        #P4 (list (- #W/2) #Y0)
        #P5 (list 0 (- #RAD))
        #P6 (list #W/2 #Y0 1))
  (initget 1)
  (setq #PT0 (getpoint "\nInsert point: "))
  (@BLOCK)
  (@POLYLINE (list #P1 #P2 #P3 #P4 #P5 #P6))
  (@INSERT (list (cons 10 #PT0))))

 (setvar "cmdecho" 0)
 (setq #DCL-FILE (vl-filename-mktemp "2Dksft.dcl")
       #FILE (open #DCL-FILE "w"))
 (foreach #X #DCL-LIST (write-line #X #FILE))
 (close #FILE)
 (if (< (setq #DCL-ID (load_dialog #DCL-FILE)) 0)
  (progn
   (alert "\nCan't load DCL file.")
   (quit))
  (vl-file-delete #DCL-FILE))
 (if (not (new_dialog "ksft2d" #DCL-ID)) (quit))
 (setq #KEY "square"
       #DIA 1.000
       #SIZE (assoc #DIA #SIZELIST))
 (start_list "size")
 (foreach #X #SIZELIST
  (add_list (rtos (car #X))))
 (end_list)
 (set_tile "key" #KEY)
 (set_tile "size" (itoa (vl-position #SIZE #SIZELIST)))
 (action_tile "accept" "(done_dialog 1)")
 (action_tile "bore" "(setq #BORE $value)")
 (action_tile "ohyeahcad" "(done_dialog 2)")
 (action_tile "key" "(setq #KEY $value)")
 (action_tile "help" "(alert #HELP)")
 (action_tile "size"
  "(setq #SIZE (nth (atoi $value) #SIZELIST) #DIA (car #SIZE)) (@GRAY)")
 (setq #GO (start_dialog))
 (cond
  ((= #GO 1) (@SFT-DRAW))
  ((= #GO 2) (command "_.browser" "www.ohyeahcad.com")))
 (princ))


;;; Uncomment for the language needed.
;(princ "\n\n2DKSFT ͂ĊJn")  ; For Japanese.
(princ "\n\nType 2DKSFT to start.") ; For English.

(princ)
